/*
Copyright 2022 The Kubeflow Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"context"

	v1beta1 "github.com/kubeflow/katib/pkg/apis/controller/suggestions/v1beta1"
	suggestionsv1beta1 "github.com/kubeflow/katib/pkg/client/controller/applyconfiguration/suggestions/v1beta1"
	scheme "github.com/kubeflow/katib/pkg/client/controller/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// SuggestionsGetter has a method to return a SuggestionInterface.
// A group's client should implement this interface.
type SuggestionsGetter interface {
	Suggestions(namespace string) SuggestionInterface
}

// SuggestionInterface has methods to work with Suggestion resources.
type SuggestionInterface interface {
	Create(ctx context.Context, suggestion *v1beta1.Suggestion, opts v1.CreateOptions) (*v1beta1.Suggestion, error)
	Update(ctx context.Context, suggestion *v1beta1.Suggestion, opts v1.UpdateOptions) (*v1beta1.Suggestion, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, suggestion *v1beta1.Suggestion, opts v1.UpdateOptions) (*v1beta1.Suggestion, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta1.Suggestion, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta1.SuggestionList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.Suggestion, err error)
	Apply(ctx context.Context, suggestion *suggestionsv1beta1.SuggestionApplyConfiguration, opts v1.ApplyOptions) (result *v1beta1.Suggestion, err error)
	// Add a +genclient:noStatus comment above the type to avoid generating ApplyStatus().
	ApplyStatus(ctx context.Context, suggestion *suggestionsv1beta1.SuggestionApplyConfiguration, opts v1.ApplyOptions) (result *v1beta1.Suggestion, err error)
	SuggestionExpansion
}

// suggestions implements SuggestionInterface
type suggestions struct {
	*gentype.ClientWithListAndApply[*v1beta1.Suggestion, *v1beta1.SuggestionList, *suggestionsv1beta1.SuggestionApplyConfiguration]
}

// newSuggestions returns a Suggestions
func newSuggestions(c *SuggestionV1beta1Client, namespace string) *suggestions {
	return &suggestions{
		gentype.NewClientWithListAndApply[*v1beta1.Suggestion, *v1beta1.SuggestionList, *suggestionsv1beta1.SuggestionApplyConfiguration](
			"suggestions",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *v1beta1.Suggestion { return &v1beta1.Suggestion{} },
			func() *v1beta1.SuggestionList { return &v1beta1.SuggestionList{} }),
	}
}
