/*
Copyright 2022 The Kubeflow Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1beta1

import (
	v1beta1 "github.com/kubeflow/katib/pkg/apis/controller/suggestions/v1beta1"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/listers"
	"k8s.io/client-go/tools/cache"
)

// SuggestionLister helps list Suggestions.
// All objects returned here must be treated as read-only.
type SuggestionLister interface {
	// List lists all Suggestions in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.Suggestion, err error)
	// Suggestions returns an object that can list and get Suggestions.
	Suggestions(namespace string) SuggestionNamespaceLister
	SuggestionListerExpansion
}

// suggestionLister implements the SuggestionLister interface.
type suggestionLister struct {
	listers.ResourceIndexer[*v1beta1.Suggestion]
}

// NewSuggestionLister returns a new SuggestionLister.
func NewSuggestionLister(indexer cache.Indexer) SuggestionLister {
	return &suggestionLister{listers.New[*v1beta1.Suggestion](indexer, v1beta1.Resource("suggestion"))}
}

// Suggestions returns an object that can list and get Suggestions.
func (s *suggestionLister) Suggestions(namespace string) SuggestionNamespaceLister {
	return suggestionNamespaceLister{listers.NewNamespaced[*v1beta1.Suggestion](s.ResourceIndexer, namespace)}
}

// SuggestionNamespaceLister helps list and get Suggestions.
// All objects returned here must be treated as read-only.
type SuggestionNamespaceLister interface {
	// List lists all Suggestions in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.Suggestion, err error)
	// Get retrieves the Suggestion from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta1.Suggestion, error)
	SuggestionNamespaceListerExpansion
}

// suggestionNamespaceLister implements the SuggestionNamespaceLister
// interface.
type suggestionNamespaceLister struct {
	listers.ResourceIndexer[*v1beta1.Suggestion]
}
